| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | |
| 3 | ## |
| 4 | # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U. |
| 5 | # This file is part of openmano |
| 6 | # All Rights Reserved. |
| 7 | # |
| 8 | # Licensed under the Apache License, Version 2.0 (the "License"); you may |
| 9 | # not use this file except in compliance with the License. You may obtain |
| 10 | # a copy of the License at |
| 11 | # |
| 12 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 13 | # |
| 14 | # Unless required by applicable law or agreed to in writing, software |
| 15 | # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT |
| 16 | # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the |
| 17 | # License for the specific language governing permissions and limitations |
| 18 | # under the License. |
| 19 | # |
| 20 | # For those usages not covered by the Apache License, Version 2.0 please |
| 21 | # contact with: nfvlabs@tid.es |
| 22 | ## |
| 23 | |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 24 | #ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 25 | #Get needed packages, source code and configure to run openmano |
| 26 | #Ask for database user and password if not provided |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 27 | |
| 28 | function usage(){ |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 29 | echo -e "usage: sudo $0 [OPTIONS]" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 30 | echo -e "Install last stable source code in ./openmano and the needed packages" |
| 31 | echo -e "On a Ubuntu 16.04 it configures openmano as a service" |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 32 | echo -e " OPTIONS" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 33 | echo -e " -u USER: database admin user. 'root' by default. Prompts if needed" |
| 34 | echo -e " -p PASS: database admin password to be used or installed. Prompts if needed" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 35 | echo -e " -q --quiet: install in unattended mode" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 36 | echo -e " -h --help: show this help" |
| 37 | echo -e " --develop: install last version for developers, and do not configure as a service" |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 38 | echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one" |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 39 | echo -e " --updatedb: do not reinstall mano_db DB if exist, just update database" |
| 40 | echo -e " --force: makes idenpotent, delete previous installations folders if needed. It assumes --updatedb if --forcedb option is not provided" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 41 | echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo" |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 42 | echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation" |
| garciadeblas | 5b1a664 | 2017-04-18 10:10:31 +0200 | [diff] [blame] | 43 | echo -e " --no-db: do not install mysql server" |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 44 | } |
| 45 | |
| 46 | function install_packages(){ |
| 47 | [ -x /usr/bin/apt-get ] && apt-get install -y $* |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 48 | [ -x /usr/bin/yum ] && yum install -y $* |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 49 | |
| 50 | #check properly installed |
| 51 | for PACKAGE in $* |
| 52 | do |
| 53 | PACKAGE_INSTALLED="no" |
| 54 | [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes" |
| 55 | [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes" |
| 56 | if [ "$PACKAGE_INSTALLED" = "no" ] |
| 57 | then |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 58 | echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2 |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 59 | exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 60 | fi |
| 61 | done |
| 62 | } |
| 63 | |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 64 | GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git |
| garciadeblas | c53ebfa | 2017-03-31 16:02:13 +0200 | [diff] [blame] | 65 | GIT_OVIM_URL=https://osm.etsi.org/gerrit/osm/openvim.git |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 66 | DBUSER="root" |
| 67 | DBPASSWD="" |
| 68 | DBPASSWD_PARAM="" |
| 69 | QUIET_MODE="" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 70 | DEVELOP="" |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 71 | DB_FORCE_UPDATE="" |
| 72 | UPDATEDB="" |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 73 | FORCE="" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 74 | NOCLONE="" |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 75 | NO_PACKAGES="" |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 76 | NO_DB="" |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 77 | while getopts ":u:p:hiq-:" o; do |
| 78 | case "${o}" in |
| 79 | u) |
| 80 | export DBUSER="$OPTARG" |
| 81 | ;; |
| 82 | p) |
| 83 | export DBPASSWD="$OPTARG" |
| 84 | export DBPASSWD_PARAM="-p$OPTARG" |
| 85 | ;; |
| 86 | q) |
| 87 | export QUIET_MODE=yes |
| 88 | export DEBIAN_FRONTEND=noninteractive |
| 89 | ;; |
| 90 | h) |
| 91 | usage && exit 0 |
| 92 | ;; |
| 93 | -) |
| 94 | [ "${OPTARG}" == "help" ] && usage && exit 0 |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 95 | [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 96 | [ "${OPTARG}" == "forcedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--forcedb" && continue |
| 97 | [ "${OPTARG}" == "updatedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--updatedb" && continue |
| 98 | [ "${OPTARG}" == "force" ] && FORCE="y" && continue |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 99 | [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 100 | [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 101 | [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 102 | [ "${OPTARG}" == "no-db" ] && NO_DB="y" && continue |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 103 | echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2 |
| 104 | exit 1 |
| 105 | ;; |
| 106 | \?) |
| 107 | echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2 |
| 108 | exit 1 |
| 109 | ;; |
| 110 | :) |
| 111 | echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2 |
| 112 | exit 1 |
| 113 | ;; |
| 114 | *) |
| 115 | usage >&2 |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 116 | exit 1 |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 117 | ;; |
| 118 | esac |
| 119 | done |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 120 | |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 121 | if [ "$DB_FORCE_UPDATE" == "--forcedb--updatedb" ] || [ "$DB_FORCE_UPDATE" == "--updatedb--forcedb" ] ; then |
| 122 | echo "Error: options --forcedb and --updatedb are mutually exclusive" >&2 |
| 123 | exit 1 |
| 124 | elif [ -n "$FORCE" ] && [ -z "$DB_FORCE_UPDATE" ] ; then |
| 125 | DB_FORCE_UPDATE="--updatedb" |
| 126 | fi |
| 127 | |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 128 | #check root privileges and non a root user behind |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 129 | [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1 |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 130 | if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]] |
| 131 | then |
| 132 | [[ -z $QUIET_MODE ]] && read -e -p "Install in the root user (y/N)?" KK |
| 133 | [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1 |
| 134 | export SUDO_USER=root |
| 135 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 136 | |
| 137 | #Discover Linux distribution |
| 138 | #try redhat type |
| 139 | [ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1) |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 140 | #else assuming ubuntu type |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 141 | [ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null) |
| 142 | if [ "$_DISTRO" == "Ubuntu" ] |
| 143 | then |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 144 | _RELEASE=$(lsb_release -rs) |
| 145 | if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]] |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 146 | then |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 147 | [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)'? (y/N)" KK |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 148 | [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1 |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 149 | _RELEASE = 14 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 150 | fi |
| 151 | elif [ "$_DISTRO" == "CentOS" ] |
| 152 | then |
| 153 | _RELEASE="7" |
| 154 | if ! cat /etc/redhat-release | grep -q "7." |
| 155 | then |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 156 | [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested CentOS version. Continue assuming a '_RELEASE' type? (y/N)" KK |
| 157 | [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 158 | fi |
| 159 | elif [ "$_DISTRO" == "Red" ] |
| 160 | then |
| 161 | _RELEASE="7" |
| 162 | if ! cat /etc/redhat-release | grep -q "7." |
| 163 | then |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 164 | [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Red Hat OS version. Continue assuming a '_RELEASE' type? (y/N)" KK |
| 165 | [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 166 | fi |
| 167 | else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ] |
| 168 | _DISTRO_DISCOVER=$_DISTRO |
| 169 | [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14" |
| 170 | [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7" |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 171 | [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type? (y/N)" KK |
| 172 | [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1 |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 173 | fi |
| 174 | |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 175 | #check if installed as a service |
| 176 | INSTALL_AS_A_SERVICE="" |
| 177 | [[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y" |
| 178 | #Next operations require knowing OPENMANO_BASEFOLDER |
| 179 | if [[ -z "$NOCLONE" ]]; then |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 180 | if [[ -n "$INSTALL_AS_A_SERVICE" ]] ; then |
| 181 | OPENMANO_BASEFOLDER=__openmano__${RANDOM} |
| 182 | else |
| 183 | OPENMANO_BASEFOLDER="${PWD}/openmano" |
| 184 | fi |
| 185 | [[ -n "$FORCE" ]] && rm -rf $OPENMANO_BASEFOLDER #make idempotent |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 186 | else |
| 187 | HERE=$(realpath $(dirname $0)) |
| 188 | OPENMANO_BASEFOLDER=$(dirname $HERE) |
| 189 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 190 | |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 191 | if [[ -z "$NO_PACKAGES" ]] #if (UPDATE REPOS) |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 192 | then |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 193 | echo ' |
| 194 | ################################################################# |
| 195 | ##### UPDATE REPOSITORIES ##### |
| 196 | #################################################################' |
| 197 | [ "$_DISTRO" == "Ubuntu" ] && apt-get update -y |
| 198 | |
| 199 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y |
| 200 | [ "$_DISTRO" == "CentOS" ] && sudo yum install -y epel-release |
| 201 | [ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \ |
| 202 | && sudo rpm -ivh epel-release-7-5.noarch.rpm && sudo yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm |
| 203 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && sudo yum repolist |
| 204 | |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 205 | fi #if (UPDATE REPOS) |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 206 | |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 207 | if [[ -z "$NO_PACKAGES" ]] #if (INSTALL DEPENDENCIES) |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 208 | then |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 209 | echo ' |
| 210 | ################################################################# |
| 211 | ##### INSTALL REQUIRED PACKAGES ##### |
| 212 | #################################################################' |
| tierno | 05a8b7b | 2017-04-20 18:56:07 +0200 | [diff] [blame] | 213 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "git make screen wget mysql-client" |
| 214 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git make screen wget mariadb-client" |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 215 | fi #if (INSTALL DEPENDENCIES) |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 216 | |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 217 | if [[ -z "$NO_PACKAGES" ]] #if (PYTHON PACKAGES AND PIP PACKAGES) |
| tierno | 7684184 | 2016-09-27 09:18:28 +0000 | [diff] [blame] | 218 | then |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 219 | echo ' |
| 220 | ################################################################# |
| 221 | ##### INSTALL PYTHON PACKAGES ##### |
| 222 | #################################################################' |
| bayramov | fe3f3c9 | 2016-10-04 07:53:41 +0400 | [diff] [blame] | 223 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev python-pip" |
| 224 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel python-pip" |
| tierno | f70d096 | 2017-01-30 12:39:09 +0100 | [diff] [blame] | 225 | #The only way to install python-bottle on Centos7 is with easy_install or pip |
| 226 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle |
| bayramov | fe3f3c9 | 2016-10-04 07:53:41 +0400 | [diff] [blame] | 227 | |
| 228 | #required for vmware connector TODO move that to separete opt in install script |
| 229 | sudo pip install --upgrade pip |
| 230 | sudo pip install pyvcloud |
| 231 | sudo pip install progressbar |
| 232 | sudo pip install prettytable |
| bhangare | fda5f7c | 2017-01-12 23:50:34 -0800 | [diff] [blame] | 233 | sudo pip install pyvmomi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 234 | |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 235 | #required for AWS connector |
| tierno | f70d096 | 2017-01-30 12:39:09 +0100 | [diff] [blame] | 236 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-boto" |
| 237 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-boto" #TODO check if at Centos it exist with this name, or PIP should be used |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 238 | |
| 239 | #install openstack client needed for using openstack as a VIM |
| tierno | 93bffb4 | 2016-12-31 17:08:51 +0100 | [diff] [blame] | 240 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient" |
| 241 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient #TODO revise if gcc python-pip is needed |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 242 | fi #if (PYTHON PACKAGES AND PIP PACKAGES) |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 243 | |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 244 | if [[ -z $NOCLONE ]]; then |
| 245 | echo ' |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 246 | ################################################################# |
| 247 | ##### DOWNLOAD SOURCE ##### |
| 248 | #################################################################' |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 249 | su $SUDO_USER -c "git clone ${GIT_URL} ${OPENMANO_BASEFOLDER}" |
| 250 | su $SUDO_USER -c "cp ${OPENMANO_BASEFOLDER}/.gitignore-common ${OPENMANO_BASEFOLDER}/.gitignore" |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 251 | [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER} checkout v2.0" |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 252 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 253 | |
| 254 | echo ' |
| 255 | ################################################################# |
| garciadeblas | c53ebfa | 2017-03-31 16:02:13 +0200 | [diff] [blame] | 256 | ##### INSTALLING OVIM LIBRARY ##### |
| 257 | #################################################################' |
| 258 | su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER} clone ${GIT_OVIM_URL} openvim" |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 259 | [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER}/openvim checkout v2.0" |
| garciadeblas | e02ee6e | 2017-04-24 13:01:45 +0200 | [diff] [blame^] | 260 | trap 'rm -rf "${OPENMANO_BASEFOLDER}/openvim"' EXIT |
| 261 | |
| garciadeblas | c53ebfa | 2017-03-31 16:02:13 +0200 | [diff] [blame] | 262 | # Install debian dependencies before setup.py |
| garciadeblas | aa1044b | 2017-04-21 07:12:17 +0200 | [diff] [blame] | 263 | [ "$_DISTRO" == "Ubuntu" ] && install_packages "libmysqlclient-dev" |
| 264 | [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "libmysqlclient-dev" #TODO check if that's the name in CentOS and RedHat |
| garciadeblas | c53ebfa | 2017-03-31 16:02:13 +0200 | [diff] [blame] | 265 | make -C ${OPENMANO_BASEFOLDER}/openvim lite |
| garciadeblas | d5b5dcc | 2017-04-21 13:05:56 +0200 | [diff] [blame] | 266 | OSMLIBOVIM_PATH=`python -c 'import lib_osm_openvim; print lib_osm_openvim.__path__[0]'` |
| garciadeblas | c53ebfa | 2017-03-31 16:02:13 +0200 | [diff] [blame] | 267 | |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 268 | if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] |
| 269 | then |
| 270 | echo ' |
| 271 | ################################################################# |
| 272 | ##### CONFIGURE firewalld ##### |
| 273 | #################################################################' |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 274 | KK=yes |
| 275 | [[ -z $QUIET_MODE ]] && read -e -p "Configure firewalld for openmanod port 9090? (Y/n)" KK |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 276 | if [ "$KK" != "n" -a "$KK" != "no" ] |
| 277 | then |
| 278 | #Creates a service file for openmano |
| 279 | echo '<?xml version="1.0" encoding="utf-8"?> |
| 280 | <service> |
| 281 | <short>openmanod</short> |
| 282 | <description>openmanod service</description> |
| 283 | <port protocol="tcp" port="9090"/> |
| 284 | </service>' > /etc/firewalld/services/openmanod.xml |
| 285 | #put proper permissions |
| 286 | pushd /etc/firewalld/services > /dev/null |
| 287 | restorecon openmanod.xml |
| 288 | chmod 640 openmanod.xml |
| 289 | popd > /dev/null |
| 290 | #Add the openmanod service to the default zone permanently and reload the firewall configuration |
| 291 | firewall-cmd --permanent --add-service=openmanod > /dev/null |
| 292 | firewall-cmd --reload > /dev/null |
| 293 | echo "done." |
| 294 | else |
| 295 | echo "skipping." |
| 296 | fi |
| 297 | fi |
| 298 | |
| 299 | echo ' |
| 300 | ################################################################# |
| 301 | ##### CONFIGURE OPENMANO CLIENT ##### |
| 302 | #################################################################' |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 303 | #creates a link at ~/bin if not configured as a service |
| 304 | if [[ -z "$INSTALL_AS_A_SERVICE" ]] |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 305 | then |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 306 | su $SUDO_USER -c 'mkdir -p ${HOME}/bin' |
| 307 | su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano' |
| 308 | su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report' |
| 309 | su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano' |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 310 | su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/openmano' "'${HOME}/bin/openmano' |
| 311 | su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/openmano-report.sh' "'${HOME}/bin/openmano-report' |
| 312 | su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh' "'${HOME}/bin/service-openmano' |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 313 | |
| 314 | #insert /home/<user>/bin in the PATH |
| 315 | #skiped because normally this is done authomatically when ~/bin exist |
| 316 | #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin" |
| 317 | #then |
| 318 | # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc" |
| 319 | # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc' |
| 320 | #fi |
| 321 | if [[ $SUDO_USER == root ]] |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 322 | then |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 323 | if ! echo $PATH | grep -q "${HOME}/bin" |
| 324 | then |
| 325 | echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc |
| 326 | fi |
| 327 | fi |
| 328 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 329 | |
| 330 | #configure arg-autocomplete for this user |
| 331 | #in case of minimal instalation this package is not installed by default |
| 332 | [[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion |
| 333 | #su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d' |
| 334 | su $SUDO_USER -c 'activate-global-python-argcomplete --user' |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 335 | if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc' |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 336 | then |
| 337 | echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc" |
| tierno | c50e5da | 2016-07-06 17:49:45 +0200 | [diff] [blame] | 338 | su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc' |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 339 | fi |
| 340 | |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 341 | if [ -z "$NO_DB" ]; then |
| 342 | echo ' |
| 343 | ################################################################# |
| 344 | ##### INSTALL DATABASE SERVER ##### |
| 345 | #################################################################' |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 346 | |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 347 | if [ -n "$QUIET_MODE" ]; then |
| 348 | DB_QUIET='-q' |
| 349 | fi |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 350 | ${OPENMANO_BASEFOLDER}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} $DB_QUIET $DB_FORCE_UPDATE || exit 1 |
| tierno | 05a8b7b | 2017-04-20 18:56:07 +0200 | [diff] [blame] | 351 | echo ' |
| 352 | ################################################################# |
| 353 | ##### CREATE AND INIT MANO_VIM DATABASE ##### |
| 354 | #################################################################' |
| 355 | # Install mano_vim_db after setup |
| tierno | 443c84a | 2017-04-24 12:31:33 +0200 | [diff] [blame] | 356 | ${OSMLIBOVIM_PATH}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} -u mano -p manopw -d mano_vim_db $DB_QUIET $DB_FORCE_UPDATE || exit 1 |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 357 | |
| Gennadiy Dubina | 89cb0d1 | 2017-04-03 15:46:41 +0300 | [diff] [blame] | 358 | fi |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 359 | |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 360 | if [[ -n "$INSTALL_AS_A_SERVICE" ]] |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 361 | then |
| 362 | echo ' |
| 363 | ################################################################# |
| 364 | ##### CONFIGURE OPENMANO SERVICE ##### |
| 365 | #################################################################' |
| 366 | |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 367 | ${OPENMANO_BASEFOLDER}/scripts/install-openmano-service.sh -f ${OPENMANO_BASEFOLDER} `[[ -z "$NOCLONE" ]] && echo "-d"` |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 368 | # rm -rf ${OPENMANO_BASEFOLDER} |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 369 | # alias service-openmano="service openmano" |
| 370 | # echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc |
| 371 | |
| 372 | echo |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 373 | echo "Done! installed at /opt/openmano" |
| 374 | echo " Manage server with 'sudo service openmano start|stop|status|...' " |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 375 | |
| 376 | |
| 377 | else |
| 378 | |
| 379 | echo |
| 380 | echo "Done! you may need to logout and login again for loading client configuration" |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 381 | echo " Run './${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh start' for starting openmano in a screen" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 382 | |
| 383 | fi |
| garciadeblas | 16304ba | 2016-05-11 14:47:39 +0200 | [diff] [blame] | 384 | |